function ToggleVote()
	if(ElgohVote:IsShown()) then 
		ElgohVote:Hide();
		frmMain:SetHeight(frmMain:GetHeight()-ElgohVote:GetHeight())
	else
		if(edtItem:GetText()=="") then edtItem:SetText("Item"); end
		ElgohVote:Show();
		frmMain:SetHeight(frmMain:GetHeight()+ElgohVote:GetHeight())
	end
end

function OVoteT()
	if(OElgohVote:IsShown()) then 
		OElgohVote:Hide();
		frmOfficer:SetHeight(frmOfficer:GetHeight()-OElgohVote:GetHeight())
	else
		OElgohVote:Show();
		OElgohVote:SetWidth(frmOfficer:GetWidth());
		frmOfficer:SetHeight(frmOfficer:GetHeight()+OElgohVote:GetHeight())
		if(PollTitle==nil) then
			Poll_New();
		end
	end
end

function Vote_Refresh()
	for n=1,#PollItems do
		if(VoteButtons[n]==nil) then
			VoteButtons[n]=CreateFrame("Button",nil,caMain,"UIPanelButtonTemplate")
			VoteButtons[n]:RegisterForClicks("AnyUp");
			VoteButtons[n]:SetScript("OnClick", toggle);
			if(n<6) then
				VoteButtons[n]:SetPoint("TOPLEFT", "caMain", "TOPLEFT", 15, -((n*25)));
			else
				VoteButtons[n]:SetPoint("TOPLEFT", "caMain", "TOPLEFT", 180, -(((n-5)*25)));
			end
			VoteButtons[n]:SetWidth(150)
			VoteButtons[n]:SetHeight(25)
		end
		if(GetRaidRosterInfo(n)) then
			VoteButtons[n]:SetText("|cffffffff"..raidername.." hasn't given|r");
			height=height+25;
		else
			VoteButtons[n]:Hide();
		end
	end
end

function Poll_New()
	PollItems = {};
	PollVotes = {};
	PollVoting = false;
	PollTitle="Officer Vote:";
	PollButtons={};
end

function Poll_SetItem(itemName, index)
	if (index ~= nil) then
		index = math.floor(index)
		PollItems[index] = itemName
	end

	Poll_OrderItems();
	Poll_List();
	return true
end

function Elgoh_RemoveItem(index)
	if (PollItems[index] == nil) then
		print("Elgoh: Item "..index.." doesn't exist");
		PlaySoundFile("Sound\\interface\\Error.wav")
		return false
	end

	frmOfficer:SetHeight(frmOfficer:GetHeight()-30)
	table.remove(PollItems, index)
	Poll_OrderItems()
	return true
end

function Elgoh_AddItem(item)
	for index=1,#PollItems do
		if (PollItems[index] == item) then
			print("Elgoh: Item already exist at "..index);
			PlaySoundFile("Sound\\interface\\Error.wav");
			return false;
		end
	end
	
	--
	
	-- Add the text and remove buttons
	
	--
	
	frmOfficer:SetHeight(frmOfficer:GetHeight()+30)
	edtItem:SetText("");
	table.insert(PollItems, index)
	PollItems[index]=item;
	Poll_OrderItems()
	return true
end

function Poll_List()
	local index, itemName
	print("Elgoh: Current items in the vote:");
	for index, itemName in pairs(PollItems) do
		print(index..": "..itemName)
	end
end

function Poll_Vote(player, index)
	local index
	local indexValid, alreadyVoted

	if (not PollVoting) then
		return false
	end

	indexValid = (index ~= nil) and (PollItems[index] ~= nil)

	alreadyVoted = (PollVotes[player] ~= nil)

	if (not indexValid or alreadyVoted) then
		return false
	end

	PollVotes[player] = {}
	PollVotes[player]['item']   = index

	local numVotes = 0
	for _, _ in pairs(PollVotes) do
		numVotes = numVotes + 1
	end

	if (numVotes == GetNumRaidMembers()) then
		Poll_StopVote()
	end

	return true
end

function Poll_StartVote()
	if (PollVoting == true) then
		print("Elgoh: Another vote is already in progress");
		return false
	end
	
	if (#PollItems < 2) then
		print("Elgoh: You need to add at least 2 items");
		return false
	end
	
	PollVoteDuration = 15;
	PollVotes = {}
	ElgohVote.TimeSinceLastUpdate = 0
	PollVoting = true
	SendAddonMessage("elgohv", "new", "RAID");
end

function Poll_StopVote()
	PollVoting = false
	Poll_New();
end

function Poll_GetResults()
	local itemsCount = {}
	local player, playerRow, index
	local totalCount = 0

	for index, _ in pairs(PollItems) do
		itemsCount[index] = {}
		itemsCount[index]['num']  = 0
		itemsCount[index]['item'] = index
	end

	for player, playerRow in pairs(PollVotes) do
		itemsCount[playerRow['item']]['num'] = itemsCount[playerRow['item']]['num'] + 1
		totalCount = totalCount + 1
	end

	table.sort(itemsCount, Poll_CompareResults)

	local resultsTable = {}
	local value
	local position = 1

	if (totalCount == 0) then
		totalCount = 1
	end

	for index, value in pairs(itemsCount) do
		table.insert(resultsTable, position..". "..PollItems[value['item']].." : "..value['num'].." ("..math.floor(0.5 + 100 * value['num'] / totalCount).." %)")
		position = position + 1
	end

	return resultsTable
end

function Poll_OrderItems()
	local index, itemName
	local indexes, newItemList
	newItemList = {}
	indexes = {}
	
	for index, _ in pairs(PollItems) do
		table.insert(indexes, index)
	end
	
	table.sort(indexes)
	
	for _, index in pairs(indexes) do
		newItemList[index] = PollItems[index]
	end

	PollItems = newItemList
end

function Poll_OnLoad()
	ElgohVote:RegisterEvent("CHAT_ADDON_MESSAGE");
	ElgohVote.TimeSinceLastUpdate = 0;
	PollVoting = false;
	ElgohVote:SetScript("OnEvent",  Poll_OnEvent);
	ElgohVote:SetScript("OnUpdate", Poll_OnUpdate);
end


function Poll_OnEvent(event, ...)
if (event == "CHAT_ADDON_MESSAGE") then
	local prefix, msg, how, who = select(1, ...);
	if(msg=="new") then
		PollVoting=true;
	else
		PollVote(who, msg);
	end
end
end


function Poll_OnUpdate(this, arg1)
	if ((not PollVoting) or (PollVoteDuration == 0)) then return end
	
	ElgohVote.TimeSinceLastUpdate = ElgohVote.TimeSinceLastUpdate + arg1
	if( ElgohVote.TimeSinceLastUpdate > PollVoteDuration ) then
		Poll_StopVote()
	end
end